stages:          # List of stages for jobs, and their order of execution
- build
- deploy

variables:
  DOCKER_NAME: skanestas
  #DOCKER_HOST: tcp://docker:2375 
  DOCKER_TLS_CERTDIR: ""
  CI_COMMIT_REF_SLUG: latest

build:
  # Official docker image.
  image: docker:latest
  stage: build
  services:
    - docker:dind
  #- name: docker:dind
  #  alias: docker
  #  command: ["--tls=false"]

  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker build --pull -t "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG" .
    #- export DOCKER_HOST=tcp://localhost:2375 && docker build --pull -t "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG" .
    #- docker build --pull -t "$CI_REGISTRY/nassa9/occamfi:${tag}" .
    #- docker push "$CI_REGISTRY_IMAGE"
    - docker push "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG"
    - echo soon11111

deploy-docker-compose:
  image: docker:lates
  stage: deploy
  services:
    - docker:dind
  variables:
    DEPLOY_DOCKER_HOST: "89.208.229.168"
    DEPLOY_DOCKER_PORT: 22
    SSH_USER: ubuntu
    SSH_PRIVATE_KEY: ${DOCKER_SSH_KEY}
    DEPLOY_PATH: /home/ubuntu/app
  script:
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$SSH_PRIVATE_KEY" | tr -d '\r')
    - '[[ -z ~/.ssh ]] && mkdir -p ~/.ssh'
    - chmod 700 ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - ssh $SSH_USER@$DEPLOY_DOCKER_HOST -p $DEPLOY_DOCKER_PORT "cd $DEPLOY_PATH; cp docker-compose.yml docker-compose-backup.yml"
    - docker-compose -f docker-compose.yml config | ssh $SSH_USER@$DEPLOY_DOCKER_HOST -p $DEPLOY_DOCKER_PORT "cat - > $DEPLOY_PATH/docker-compose.yml"
    - ssh $SSH_USER@$DEPLOY_DOCKER_HOST -p $DEPLOY_DOCKER_PORT "cd $DEPLOY_PATH; docker-compose pull"
    - ssh $SSH_USER@$DEPLOY_DOCKER_HOST -p $DEPLOY_DOCKER_PORT "cd $DEPLOY_PATH; docker-compose up -d --force-recreate"
